>From 962e80ebac8008e470357f98fceaee1cdcf3fb63 Mon Sep 17 00:00:00 2001
From: Erwan Tulou <brezhoneg1@yahoo.fr>
Date: Sun, 24 May 2009 20:53:52 +0200
Subject: [PATCH] skins2(X11) : correct possible hanging at the xlib level

---
 modules/gui/skins2/x11/x11_window.cpp |   12 +++++++++---
 1 files changed, 9 insertions(+), 3 deletions(-)

diff --git a/modules/gui/skins2/x11/x11_window.cpp b/modules/gui/skins2/x11/x11_window.cpp
index 3c20592..c5e92e9 100644
--- a/modules/gui/skins2/x11/x11_window.cpp
+++ b/modules/gui/skins2/x11/x11_window.cpp
@@ -59,17 +59,23 @@ X11Window::X11Window( intf_thread_t *pIntf, GenericWindow &rWindow,
     // Make sure window is created before returning
     XMapWindow( XDISPLAY, m_wnd );
     bool b_map_notify = false;
+    int count = 0;
     do
     {
+        count++;
         XEvent xevent;
-        XWindowEvent( XDISPLAY, m_wnd, SubstructureNotifyMask |
-                      StructureNotifyMask, &xevent);
+        XCheckWindowEvent( XDISPLAY, m_wnd, SubstructureNotifyMask |
+                           StructureNotifyMask, &xevent);
         if( (xevent.type == MapNotify)
              && (xevent.xmap.window == m_wnd ) )
         {
             b_map_notify = true;
         }
-    } while( ! b_map_notify );
+    } while( ! b_map_notify && count < 50 );
+
+    if( count == 50 ) 
+        msg_Dbg( getIntf(), "xlib possibly hanging (forcefully exiting from a loop)" );
+
     XUnmapWindow( XDISPLAY, m_wnd );
 
     // Set the colormap for 8bpp mode
-- 
1.5.6.5

